package ru.octol1ttle.knockdowns.client.communication;

import java.util.HashMap;
import java.util.Map;
import java.util.Set;
import net.minecraft.client.Minecraft;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import ru.octol1ttle.knockdowns.client.util.Callout;
import ru.octol1ttle.knockdowns.client.util.DirectionalCallSound;
import ru.octol1ttle.knockdowns.common.network.packets.s2c.PlayerCalloutS2CPacket;
import ru.octol1ttle.knockdowns.common.registry.KnockdownsSoundEvents;

@SideOnly(Side.CLIENT)
public class CalloutManager {
    private static final Minecraft client = Minecraft.getMinecraft();
    private static final Map<Integer, Callout> callouts = new HashMap<>();

    public static Set<Map.Entry<Integer, Callout>> getCallouts() {
        return callouts.entrySet();
    }

    public static boolean addOrUpdateCallout(PlayerCalloutS2CPacket message) {
        return callouts.put(message.playerId, new Callout(message.position, message.type, client.world.getTotalWorldTime())) == null;
    }

    public static void playCalloutSound(PlayerCalloutS2CPacket message) {
        client.getSoundHandler().playSound(new DirectionalCallSound(KnockdownsSoundEvents.CALLOUT, client.world.getEntityByID(message.playerId), message.position));
    }

    public static void clearCallouts() {
        callouts.clear();
    }
}
