package ru.octol1ttle.knockdowns.common.communication;

public enum CalloutType {
    DANGER((byte) 0, "knockdowns.callout.danger"),
    BOOYAH((byte) 1, "knockdowns.callout.booyah"),
    THIS_WAY((byte) 2, "knockdowns.callout.this_way"),
    OUCH((byte) 3, "knockdowns.callout.ouch"),
    HELP((byte) 4, "knockdowns.callout.help");

    private final byte id;
    private final String textKey;

    CalloutType(byte id, String textKey) {
        this.id = id;
        this.textKey = textKey;
    }

    public byte getId() {
        return id;
    }

    public String getTextKey() {
        return textKey;
    }

    public static CalloutType byId(byte id) {
        for (CalloutType type : CalloutType.values()) {
            if (id == type.getId()) {
                return type;
            }
        }

        throw new IllegalArgumentException();
    }
}
