package ru.octol1ttle.knockdowns.common.data;

import java.util.Objects;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraftforge.common.util.INBTSerializable;
import ru.octol1ttle.knockdowns.common.util.UniqueOnlyList;

public interface IKnockdownsPlayerData extends INBTSerializable<NBTTagCompound> {
    boolean isKnockedDown();
    void setKnockedDown(boolean knockedDown);

    int getReviveTimeLeft();
    void setReviveTimeLeft(int reviveTimeLeft);

    int getTicksKnocked();
    void setTicksKnocked(int ticksKnocked);

    UniqueOnlyList<EntityPlayer> getRevivers();

    static IKnockdownsPlayerData get(EntityPlayer player) {
        return Objects.requireNonNull(player.getCapability(KnockdownsCapability.CAPABILITY, null));
    }
}
