package ru.octol1ttle.knockdowns.common.network;

import java.util.List;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;
import net.minecraftforge.fml.common.network.simpleimpl.IMessageHandler;
import net.minecraftforge.fml.common.network.simpleimpl.MessageContext;
import ru.octol1ttle.knockdowns.common.data.IKnockdownsPlayerData;
import ru.octol1ttle.knockdowns.common.network.packets.c2s.CancelReviveC2SPacket;
import ru.octol1ttle.knockdowns.common.network.packets.c2s.PlayerCalloutC2SPacket;
import ru.octol1ttle.knockdowns.common.network.packets.s2c.PlayerCalloutS2CPacket;
import ru.octol1ttle.knockdowns.common.network.packets.s2c.SynchronizeReviversS2CPacket;

public class KnockdownsServerPacketHandler {
    public static class Callout implements IMessageHandler<PlayerCalloutC2SPacket, IMessage> {
        @Override
        public IMessage onMessage(PlayerCalloutC2SPacket message, MessageContext ctx) {
            KnockdownsNetwork.sendToDimension(
                    new PlayerCalloutS2CPacket(
                            ctx.getServerHandler().player.getEntityId(),
                            ctx.getServerHandler().player.getPositionEyes(1).add(0, 1, 0),
                            message.type
                    ),
                    ctx
            );
            return null;
        }
    }

    public static class CancelRevive implements IMessageHandler<CancelReviveC2SPacket, IMessage> {
        @Override
        public IMessage onMessage(CancelReviveC2SPacket message, MessageContext ctx) {
            EntityPlayerMP player = ctx.getServerHandler().player;
            for (EntityPlayer knocked : player.world.playerEntities) {
                List<EntityPlayer> revivers = IKnockdownsPlayerData.get(knocked).getRevivers();
                if (revivers.contains(player)) {
                    revivers.remove(player);
                    KnockdownsNetwork.sendToMultiple(
                            new SynchronizeReviversS2CPacket.Remove(knocked.getEntityId(), player.getEntityId()),
                            revivers,
                            (EntityPlayerMP) knocked
                    );
                    break;
                }
            }

            return null;
        }
    }
}
