package ru.octol1ttle.knockdowns.common.network.packets.s2c;

import io.netty.buffer.ByteBuf;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;

public class SynchronizePlayerDataS2CPacket {
    public static class KnockedDown implements IMessage {
        public KnockedDown() {
        }

        public int playerId;
        public boolean knockedDown;

        public KnockedDown(int playerId, boolean knockedDown) {
            this.playerId = playerId;
            this.knockedDown = knockedDown;
        }

        @Override
        public void toBytes(ByteBuf buf) {
            buf.writeInt(this.playerId);
            buf.writeBoolean(this.knockedDown);
        }

        @Override
        public void fromBytes(ByteBuf buf) {
            this.playerId = buf.readInt();
            this.knockedDown = buf.readBoolean();
        }
    }

    public static class ReviveTimeLeft implements IMessage {
        public ReviveTimeLeft() {
        }

        public int playerId;
        public int reviveTimeLeft;

        public ReviveTimeLeft(int playerId, int reviveTimeLeft) {
            this.playerId = playerId;
            this.reviveTimeLeft = reviveTimeLeft;
        }

        @Override
        public void toBytes(ByteBuf buf) {
            buf.writeInt(this.playerId);
            buf.writeInt(this.reviveTimeLeft);
        }

        @Override
        public void fromBytes(ByteBuf buf) {
            this.playerId = buf.readInt();
            this.reviveTimeLeft = buf.readInt();
        }
    }

    public static class Full implements IMessage {
        public Full() {
        }

        public int playerId;
        public boolean knockedDown;
        public int reviveTimeLeft;

        public Full(int playerId, boolean knockedDown, int reviveTimeLeft) {
            this.playerId = playerId;
            this.knockedDown = knockedDown;
            this.reviveTimeLeft = reviveTimeLeft;
        }

        @Override
        public void toBytes(ByteBuf buf) {
            buf.writeInt(this.playerId);
            buf.writeBoolean(this.knockedDown);
            buf.writeInt(this.reviveTimeLeft);
        }

        @Override
        public void fromBytes(ByteBuf buf) {
            this.playerId = buf.readInt();
            this.knockedDown = buf.readBoolean();
            this.reviveTimeLeft = buf.readInt();
        }
    }
}
