package ru.octol1ttle.knockdowns.common.util;

import java.util.ArrayList;

public class UniqueOnlyList<T> extends ArrayList<T> {
    @Override
    public void add(int index, T element) {
        throw new IllegalStateException();
    }

    @Override
    public boolean add(T t) {
        if (this.contains(t)) {
            return false;
        }
        return super.add(t);
    }

    @Override
    public T set(int index, T element) {
        throw new IllegalStateException();
    }
}
