package ru.octol1ttle.knockdowns.mixin;

import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.world.World;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import ru.octol1ttle.knockdowns.common.KnockdownsUtils;
import ru.octol1ttle.knockdowns.common.data.IKnockdownsPlayerData;

@SuppressWarnings("ConstantValue")
@Mixin(EntityLivingBase.class)
public abstract class EntityLivingBaseMixin extends Entity {
    public EntityLivingBaseMixin(World worldIn) {
        super(worldIn);
    }

    @Inject(method = "checkTotemDeathProtection", at = @At("RETURN"))
    private void onTotemActivation(CallbackInfoReturnable<Boolean> cir) {
        if (cir.getReturnValue() && ((Object) this) instanceof EntityPlayerMP) {
            EntityPlayerMP player = (EntityPlayerMP) (Object) this;
            IKnockdownsPlayerData data = IKnockdownsPlayerData.get(player);
            if (data.isKnockedDown()) {
                KnockdownsUtils.resetKnockedState(player, data);
            }
        }
    }
}
